unit LowPassFilterForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls,StdCtrls, DB, DBTables, SELowPassFilter, ComCtrls, ExtCtrls,
  TeEngine, Series, TeeProcs, Chart;

const
  szStreet=512;

type
  TfrmLowPassFilter = class(TForm)
    lpf: TLowPassFilter;
    LoadTest: TButton;
    Execute: TButton;
    Chart1: TChart;
    Series1: TLineSeries;
    Chart2: TChart;
    Series2: TLineSeries;
    Chart3: TChart;
    Chart4: TChart;
    Series4: TLineSeries;
    Table1: TTable;
    Series5: TLineSeries;
    DataFromDB: TButton;
    ParmLPF: TGroupBox;
    DelOvershoot: TCheckBox;
    Bandwidth: TEdit;
    Label1: TLabel;
    DataFromDB2: TButton;
    RadioGroup1: TRadioGroup;
    ModeLpf: TRadioButton;
    ModeSn: TRadioButton;
    Series3: TLineSeries;
    HostHarmonic: TListBox;
    Chart6: TChart;
    Series7: TLineSeries;
    PbofExecute: TProgressBar;
    Break: TButton;
    ModeNF: TRadioButton;
    FR: TComboBox;
    Label2: TLabel;
    DOD: TComboBox;
    Label3: TLabel;
    Label4: TLabel;
    SND: TComboBox;
    Label5: TLabel;
    procedure LoadTestClick(Sender: TObject);
    procedure ExecuteClick(Sender: TObject);
    procedure DataFromDBClick(Sender: TObject);
    procedure lpfDeleteOvershoot(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure DataFromDB2Click(Sender: TObject);
    procedure ModeLpfClick(Sender: TObject);
    procedure ModeSnClick(Sender: TObject);
    procedure lpfBeforeExecute(Sender: TObject);
    procedure lpfAfterExecute(Sender: TObject);
    procedure lpfStepExecute(Sender: TObject; Percent: Double);
    procedure BreakClick(Sender: TObject);
    procedure ModeNFClick(Sender: TObject);
    procedure DelOvershootClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    

  end;

var
  frmLowPassFilter: TfrmLowPassFilter;

implementation

{$R *.DFM}

procedure TfrmLowPassFilter.LoadTestClick(Sender: TObject);
  var
    i, j:integer; xItem: double;
    xAmount: Integer;
    xAmplitude: array of integer;
    xFrequency: array of integer;
begin
  Chart6.Visible := true;
  series1.clear;
  series2.Clear;
  series3.Clear;
  series4.Clear;
  series5.clear;
  Series7.Clear;
  lpf.ClearArray;
  Randomize;
  xAmount := Trunc(Random * 10 + 1);
  SetLength(xAmplitude, xAmount);
  Setlength(xFrequency, xAmount);
  For j := 0 to xAmount - 1 do
  begin
    xAmplitude[j] := Trunc(Random * 3);
    xFrequency[j] := Trunc(Random * szStreet / 32);
  end;
  for i := 0 to szStreet - 1  do
    begin
      xItem := 0;
      For j := 0 to xAmount - 1 do
        xItem:= xItem + xAmplitude[j] * sin(2 * Pi * i * xFrequency[j] / szStreet) + 2;
      Series7.Add (xItem,'',clBlue);
      xItem := xItem +  15 * (Random - 0.5);
      lpf.AddInputDataItem(xItem);
      Series1.Add (xItem,'', clBlue);
    end;
end;

procedure TfrmLowPassFilter.ExecuteClick(Sender: TObject);
var i:integer;
begin
  lpf.Overshoot := DelOvershoot.Checked;
  lpf.BandWidth :=  StrToFloat(Bandwidth.Text);

  //   
  case  DOD.ItemIndex of
    0: lpf.SuppressionDegree := edSmall;
    1: lpf.SuppressionDegree := edMedium;
    2: lpf.SuppressionDegree := edLarge;
  end;
  // 
  lpf.FrequencyResolution := FR.ItemIndex + 1;
  //   
  case SND.ItemIndex of
    0: lpf.SubstractionNoiseDegree := edSmall;
    1: lpf.SubstractionNoiseDegree := edMedium;
    2: lpf.SubstractionNoiseDegree := edLarge;
  end;

  lpf.Execute;
  Series2.Clear;
  Series5.Clear;
  for i := 0 to lpf.SampleCount - 1 do
    Series2.Add(lpf.OutputDataItem[i],'',clRed);
  
  Series3.Clear;
  for i := 0 to lpf.SpectrumCount - 1 do
    Series3.Add(lpf.InputSpectrumItem[i],'',clBlue);

  Series4.Clear;
  for i := 0 to lpf.SpectrumCount - 1 do
    Series4.Add(lpf.OutputSpectrumItem[i],'',clRed);

  HostHarmonic.Clear;
  for i := 0 to lpf.HostHarmonicCount - 1 do
    HostHarmonic.Items.Add(FloatToStrF(lpf.HostHarmonicItem[i],ffFixed,18,2));
end;


procedure TfrmLowPassFilter.lpfDeleteOvershoot(Sender: TObject);
var
  i:integer;
begin
  series1.clear;
  for i := 0 to lpf.SampleCount - 1 do
    Series1.Add (lpf.InputDataItem[i],'', clBlue);
end;

procedure TfrmLowPassFilter.DataFromDBClick(Sender: TObject);
var
  i, j: integer;
  xValue: double;
  InStreet: TField;
begin
  Chart6.Visible := false;
  Table1.Active := true;
  InStreet := Table1.FieldByName('Street1');
  i := Table1.RecordCount;
  Table1.First;
  series1.clear;
  series2.Clear;
  series3.Clear;
  series4.Clear;
  series5.clear;
  lpf.ClearArray;
  For j := 0 to i - 1 do
    begin
      xValue := InStreet.AsFloat;
      lpf.AddInputDataItem(xValue);
      Series1.Add(xValue,'',clBlue);
      if j < (i-1) then
        Table1.Next;
    end;
  Table1.Active := false;
end;

procedure TfrmLowPassFilter.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  //    
  FR.Items.Clear;
  for i := 1 to 10 do
    FR.Items.Add('');

  DOD.Items.Clear;
  SND.Items.Clear;
  for i := 0 to 2 do
  begin
    DOD.Items.Add('');
    SND.Items.Add('');
  end;
end;

procedure TfrmLowPassFilter.FormActivate(Sender: TObject);
var
  i: Integer;
  strTemp: string;
begin
  //  
  DelOvershoot.Checked := lpf.Overshoot;
  if DelOvershoot.Checked then
    DOD.Enabled := true
  else
    DOD.Enabled := false;

  // 
  Bandwidth.Text:= FloatToStr(lpf.Bandwidth);

  //  
  if lpf.Mode = mdNoneFiltering then
  begin
    ModeNF.Checked := true;
    BandWidth.Enabled := false;
    SND.Enabled := false;
  end
  else if lpf.Mode = mdLowPassFilter then
       begin
         ModeLpf.Checked := true;
         SND.Enabled := false;
       end
       else
       begin
         ModeSN.Checked := true;
         BandWidth.Enabled := false;
       end;
  //    
  for i := 1 to 10 do
  begin
    FR.Items[i - 1] := IntToStr(i);
    if i = lpf.FrequencyResolution then
      FR.ItemIndex := i - 1;
  end;
  //       
  for i := 0 to 2 do
  begin
    case i of
      0: strTemp := 'Small';
      1: strTemp := 'Medium';
      2: strTemp := 'Large';
    end;
    DOD.Items[i] := strTemp;
    SND.Items[i] := strTemp;
    if Ord(lpf.SuppressionDegree) = i then
      DOD.ItemIndex := i;
    if Ord(lpf.SubstractionNoiseDegree) = i then
      SND.ItemIndex := i;
  end;

end;


procedure TfrmLowPassFilter.DataFromDB2Click(Sender: TObject);
var
  i, j: integer;
  xValue: double;
  InStreet: TField;
begin
  Chart6.Visible := false;
  Table1.Active := true;
  InStreet := Table1.FieldByName('Street2');
  i := Table1.RecordCount;
  Table1.First;
  series1.clear;
  series2.Clear;
  series3.Clear;
  series4.Clear;
  series5.clear;
  lpf.ClearArray;
  For j := 0 to i - 1 do
    begin
      xValue := InStreet.AsFloat;
      lpf.AddInputDataItem(xValue);
      Series1.Add(xValue,'',clBlue);
      if j < (i-1) then
        Table1.Next;
    end;

end;

procedure TfrmLowPassFilter.ModeLpfClick(Sender: TObject);
begin
  lpf.Mode := mdLowPassFilter;
  BandWidth.Enabled := true;
  SND.Enabled := false;
end;

procedure TfrmLowPassFilter.ModeSnClick(Sender: TObject);
begin
  lpf.Mode := mdSubtractionNoise;
  BandWidth.Enabled := false;
  SND.Enabled := true;
end;

procedure TfrmLowPassFilter.lpfBeforeExecute(Sender: TObject);
begin
  PBofExecute.Min := 0;
  PBofExecute.Max := 100;
  PBofExecute.Position := 0;
  PBofExecute.Visible := true;
end;

procedure TfrmLowPassFilter.lpfAfterExecute(Sender: TObject);
begin
  PBofExecute.Visible := false;
end;

procedure TfrmLowPassFilter.lpfStepExecute(Sender: TObject; Percent: Double);
begin
  PBofExecute.Position := Round(Percent);
end;

procedure TfrmLowPassFilter.BreakClick(Sender: TObject);
begin
  lpf.BreakExecute;
end;

procedure TfrmLowPassFilter.ModeNFClick(Sender: TObject);
begin
  lpf.Mode := mdNoneFiltering;
  BandWidth.Enabled := false;
  SND.Enabled := false;
end;

procedure TfrmLowPassFilter.DelOvershootClick(Sender: TObject);
begin
  if DelOvershoot.Checked then
    DOD.Enabled := true
  else
    DOD.Enabled := false;
end;


end.



