unit SAKalmanFilteringEditor;

interface
uses
  DesignIntf, DesignEditors,
  KalmanFiltering, SAKalmanFilteringEditDlg, Controls, SysUtils;

type
  TSAKalmanFilteringEditor =class(TComponentEditor)
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): String; override;
    procedure ExecuteVerb(Index: Integer); override;
  end;
procedure Register;

implementation

/////////////////////////////////////////
//     //
/////////////////////////////////////////
procedure Register;
begin
  RegisterComponentEditor(TKalmanFiltering, TSAKalmanFilteringEditor);
end;

///////////////////////////////////////////////////
//       //
///////////////////////////////////////////////////
function TSAKalmanFilteringEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

////////////////////////////////////////////////////////
//        //
////////////////////////////////////////////////////////
function TSAKalmanFilteringEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := 'Edit KalmanFiltering';
    else
      Result := 'Undefined Menu';
  end;
end;

////////////////////////////////////////////
//     //
////////////////////////////////////////////
procedure TSAKalmanFilteringEditor.ExecuteVerb(Index: Integer);
var
  Dialog: TSAKalmanFilteringEditDlg;

begin
  case Index of
  0:
    begin
      Dialog := TSAKalmanFilteringEditDlg.Create(nil);
      Dialog.Caption := Component.Owner.Name + '.' + Component.Name +' - ' + Dialog.Caption;
     //  
      if (Component as TKalmanFiltering).Mode = mdRecursive then
        Dialog.Recursive.Checked := true
      else
        Dialog.MovingAverage.Checked := true ;

     //  
      Dialog.Exponent.Text :=IntToStr((Component as TKalmanFiltering).FilterExponent);
     //   
      Dialog.SizeTeaching.Text := IntToStr((Component as TKalmanFiltering).SizeTeachingSequence);

     //  
      if Dialog.ShowModal = mrOK then
      begin
        //   
        if Dialog.Recursive.Checked then
          (Component as TKalmanFiltering).Mode := mdRecursive
        else
          (Component as TKalmanFiltering).Mode := mdMovingAverage;
        //  
        (Component as TKalmanFiltering). FilterExponent := StrToInt(Dialog.Exponent.Text);
        //   
        (Component as TKalmanFiltering). SizeTeachingSequence := StrToInt(Dialog.SizeTeaching.Text);
        Designer.Modified;
      end;
      Dialog.Free;

    end;
  end;
end;

end.
